"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ElectronIPCTransport = void 0;
const microservices_1 = require("@nestjs/microservices");
const event_1 = require("./libs/event");
const common_1 = require("@nestjs/common");
class ElectronIPCTransport extends microservices_1.Server {
    constructor() {
        super(...arguments);
        this.logger = new common_1.Logger(ElectronIPCTransport.name);
    }
    onMessage(messageChannel, ...args) {
        return __awaiter(this, void 0, void 0, function* () {
            const handler = this.messageHandlers.get(messageChannel);
            if (handler) {
                this.logger.debug(`Process message ${messageChannel}`);
                const [ipcMainEventObject, payload] = args;
                return yield handler(payload, {
                    evt: ipcMainEventObject,
                });
            }
            this.logger.warn(`No handlers for message ${messageChannel}`);
        });
    }
    close() {
    }
    listen(callback) {
        event_1.ipcMessageDispatcher.on('ipc-message', this.onMessage.bind(this));
        callback();
    }
}
exports.ElectronIPCTransport = ElectronIPCTransport;
__exportStar(require("./libs/decorators/AsyncIPCMessage"), exports);
