"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ipcMessageDispatcher = void 0;
const events_1 = require("events");
class IPCMessageDispatcher extends events_1.EventEmitter {
    emit(messageChannel, ...args) {
        return __awaiter(this, void 0, void 0, function* () {
            const [ipcHandler] = this.listeners('ipc-message');
            if (ipcHandler) {
                return Reflect.apply(ipcHandler, this, [messageChannel, ...args]);
            }
        });
    }
}
exports.ipcMessageDispatcher = new IPCMessageDispatcher();
